program Cycles;

{$L bgi256.obj}

uses Graph, Crt;

var Gd, Gm, i, j, X, Y: Integer;

procedure BGI256DRIVER; external;

procedure Circl;
begin
  X:=Random(GetMaxX-128)+64;
  Y:=Random(GetMaxY-128)+64;
  for i:=0 to 63 do begin
    SetColor(63-i);
    Circle(X, Y, i);
  end;
end;

procedure Rect;
begin
  X:=Random(GetMaxX-128)+64;
  Y:=Random(GetMaxY-128)+64;
  for i:=0 to 63 do begin
    SetColor(63-i+64);
    Rectangle(X-i, Y-i, X+i, Y+i);
  end;
end;

procedure Trangle;
begin
  X:=Random(GetMaxX-128)+64;
  Y:=Random(GetMaxY-128)+64;
  for i:=0 to 63 do begin
    SetColor(63-i+128);
    Line(X-i, Y+i, X+i, Y+i);
    Line(X-i, Y+i, X, Y-i);
    Line(X+i, Y+i, X, Y-i);
  end;
end;

function Initialize: Boolean;
  var Error: Integer;
begin
  Initialize:=True;
  Gd:=InstallUserDriver('BGI256', nil);
  RegisterBGIDriver(@BGI256DRIVER);
  write(gd);
  Gm:=3;
  InitGraph(Gd, Gm, '');
  Error:=GraphResult;
  if Error<>0 then begin
    Writeln('Error initialize graphics, error code #', Error);
    ReadKey;
    Initialize:=False;
  end;
end;

begin
  if not Initialize then Exit;
  for i:=0 to 63 do begin
    SetRGBPalette(i, 0, 0, i);
    SetRGBPalette(i+64, 0, i, 0);
    SetRGBPalette(i+128, i, 0, 0);
    SetRGBPalette(i+192, i, i, i);
  end;
  SetLineStyle(SolidLn, $C3, ThickWidth);
  repeat
    for j:=0 to 3 do begin
     X:=Random(GetMaxX-128)+64;
     Y:=Random(GetMaxY-128)+64;
     for i:=0 to 63 do begin
        SetColor((63-i)+64*j);
        Circle(X, Y, i);
      end;
    end;
{    ClearDevice;          }
  until KeyPressed;
  CloseGraph;
end.
